=== Maintenance/deb/sid/debian/control ===
Source: cgal
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
# "ipe" is only needed because it contains goodies.lua which is needed by FindIPE.cmake
Build-Depends: debhelper (>= 9), dpkg-awk, cmake, zlib1g-dev, libboost-dev, 
 libboost-thread-dev, libboost-program-options-dev, libboost-system-dev,
 libgmp10-dev, libmpfr-dev, libmpfi-dev, libqt4-dev, libqt4-opengl-dev, 
 libipe-dev (>= 7), ipe
Standards-Version: 3.9.3
Section: libs
Homepage: https://www.cgal.org/
XS-Autobuild: yes

Package: libcgal10
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for computational geometry
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 The CGAL library contains:
  - the Kernel with geometric primitives such as points, vectors, lines,
    predicates for testing things such as relative positions of points, and
    operations such as intersections and distance calculation.
  - the Basic Library which is a collection of standard data structures and
    geometric algorithms, such as convex hull in 2D/3D, (Delaunay)
    triangulation in 2D/3D, planar map, polyhedron, smallest enclosing circle,
    and multidimensional query structures.
  - the Support Library which offers interfaces to other packages, e.g., for
    visualisation, and I/O, and other support facilities.
 .
 This package contains the main library libCGAL.so as well as two support
 libraries libCGAL_Core.so (from the CORE project) and libCGAL_ImageIO.so
 (image I/O). The library libCGAL_Qt4.so used for visualization in demos
 can be found in the package libcgal-qt4-10.

Package: libcgal-qt4-10
Architecture: any
Depends: libcgal10 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for computational geometry (support for Qt4)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 The CGAL library contains:
  - the Kernel with geometric primitives such as points, vectors, lines,
    predicates for testing things such as relative positions of points, and
    operations such as intersections and distance calculation.
  - the Basic Library which is a collection of standard data structures and
    geometric algorithms, such as convex hull in 2D/3D, (Delaunay)
    triangulation in 2D/3D, planar map, polyhedron, smallest enclosing circle,
    and multidimensional query structures.
  - the Support Library which offers interfaces to other packages, e.g., for
    visualisation, and I/O, and other support facilities.
 .
 This package contains libCGAL_Qt4.so used for visualization in demos.

Package: libcgal-dev
Section: libdevel
Architecture: any
Depends: libcgal10 (= ${binary:Version}), libboost-dev, libboost-thread-dev,
 libboost-program-options-dev, libgmp10-dev, libmpfr-dev, zlib1g-dev, ${misc:Depends}
Description: C++ library for computational geometry (development files)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains the header files and static libraries for libCGAL.so,
 libCGAL_Core.so, and libCGAL_ImageIO.so. The  header files and static
 libraries for libCGAL_Qt4.so can be found in the package libcgal-qt4-dev.

Package: libcgal-qt4-dev
Section: libdevel
Architecture: any
Depends: libcgal10 (= ${binary:Version}), libcgal-qt4-10 (= ${binary:Version}),
 libcgal-dev, libqt4-dev, ${misc:Depends}
Description: C++ library for computational geometry (development files, support for Qt4)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains the header files and static libraries for
 libCGAL_Qt.so.

Package: libcgal-demo
Section: devel
Architecture: all
Depends: libcgal-dev (>= ${binary:Version}), libcgal10 (>= ${binary:Version}),
 ${misc:Depends}
Recommends: libcgal-qt4-dev (>= ${binary:Version}), libcgal10-qt4 (>= ${binary:Version})
Suggests: liblapack-dev, libatlas-base-dev | libatlas.so.3gf, gfortran,
 geomview, libqglviewer-qt4-dev, libipe-dev (>= 7), libglew1.5-dev | libglew-dev,
 libmagick++-dev, qt4-dev-tools, libqt4-opengl-dev, libeigen3-dev (>= 3.1.0~beta1-1)
Description: C++ library for computational geometry (demos)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains the demos and examples.

Package: libcgal-ipelets
Section: graphics
Architecture: any
Depends: libcgal10 (>= ${binary:Version}), ipe (>= ${Ipe-Version}), ipe (<< ${Ipe-Version}+),
 ${shlibs:Depends}, ${misc:Depends}
Conflicts: libcgal5-ipelets
Replaces: libcgal5-ipelets
Description: C++ library for computational geometry (ipelets)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains the ipelets, i.e., plugins for ipe.
